package com.work.provide_origin.origin

import android.app.Activity
import android.os.Bundle
import android.view.View
import android.widget.TextView
import androidx.appcompat.app.AppCompatActivity
import androidx.lifecycle.ViewModelProvider
import com.work.provide_origin.R
import com.work.provide_origin.databinding.ActivityGeneralBinding
import com.work.provide_origin.util.getVmClazz

abstract class GeneralVMActivity<VM : GeneralViewModel>:AppCompatActivity() {

//    protected lateinit var iViewModel:VM
    protected lateinit var activity:Activity
    lateinit var activityGeneralBinding: ActivityGeneralBinding
    protected abstract var layout:Int
    protected var titleFlag: Boolean = true

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        activity = this
        initDataBinding()
        initDo()
//        iViewModel = ()
        createLooker()
        initTitle(activityGeneralBinding.includeGeneralTitle)
        initUi()
        initData()
        initEvent()
    }

    protected open fun initDo(){
    }

    protected open fun initTitle(titleView:View){
        if(titleFlag){
            titleView.visibility = View.VISIBLE
            titleView.findViewById<View>(R.id.free_iv).run {
                setOnClickListener {
                    finish()
                }
            }
            titleView.findViewById<View>(R.id.finish).visibility = View.GONE
        }else {
            titleView.visibility = View.GONE
        }
    }

    protected fun setTitleNa(value:String){
        activityGeneralBinding.includeGeneralTitle.findViewById<TextView>(R.id.title).run {
            text = value
        }
    }

    protected fun getRightTv():TextView{
        return activityGeneralBinding.includeGeneralTitle.findViewById<TextView>(R.id.finish)
    }

    abstract fun initDataBinding()
    abstract fun createLooker()
    abstract fun initUi()
    abstract fun initData()
    abstract fun initEvent()
}