package com.work.provide_tool.adapter

import android.content.Context
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.databinding.DataBindingUtil
import androidx.paging.PagingDataAdapter
import androidx.recyclerview.widget.DiffUtil
import androidx.recyclerview.widget.RecyclerView
import androidx.viewbinding.ViewBinding
import com.work.provide_tool.databinding.GroupDetailWidgetBinding
import kotlinx.coroutines.CoroutineDispatcher
import kotlinx.coroutines.Dispatchers

abstract class GeneralPagingAdapter<T:Any,V:ViewBinding>(
    private val context: Context,
    diffCallback: DiffUtil.ItemCallback<T>,
    mainDispatcher: CoroutineDispatcher = Dispatchers.Main,
    workerDispatcher: CoroutineDispatcher = Dispatchers.Default): PagingDataAdapter<T,GeneralPagingAdapter.Holder<V>>(
    diffCallback
    ,mainDispatcher
    ,workerDispatcher) {
    var onClick:(View,T?,Int)->Unit = {view,t,p->}//点击
    var onLongClick:(View,T?,Int)->Unit = {view,t,p->}//长按
    var onChildClick:(View,T?,Int)->Unit = {view, t, i ->  }//子view

    protected abstract var layout:Int
    protected abstract fun onBindViewHolderWork(holder: Holder<V>,t:T?,position: Int)

    protected fun onChildClickProvide(v:View?,t:T?,p:Int){
        v?.run {
            setOnClickListener {
                onChildClick(v,t,p)
            }
        }
    }

    override fun onBindViewHolder(holder: Holder<V>, position: Int) {
        onBindViewHolderWork(holder,getItem(position),position)
        holder.rootViewType?.run {
            root.setOnClickListener {v->
                onClick(v,getItem(position),position)
            }

            root.setOnLongClickListener {v->
                onLongClick(v,getItem(position),position)
                true
            }
        }










    }










    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): Holder<V> {






















        return Holder(LayoutInflater.from(context).inflate(layout,null))
    }

    class Holder<V:ViewBinding>(itView: View):RecyclerView.ViewHolder(itView){
        val rootViewType:V? = DataBindingUtil.bind(itView)
    }
}