package com.work.provide_tool.app

import android.app.Activity
import android.app.Application
import android.os.Bundle
import android.util.Log
import com.work.provide_tool.BuildConfig
import com.work.provide_tool.util.AppActivityLeader

abstract class IApp : Application() {
    companion object{
        lateinit var app:Application
    }

    override fun onCreate() {
        super.onCreate()
        app = this
        init(this, BuildConfig.APPLICATION_FLAG)


        initAppActivity()
    }

    private fun initAppActivity(){
        registerActivityLifecycleCallbacks(object: ActivityLifecycleCallbacks{
            override fun onActivityCreated(p0: Activity, p1: Bundle?) {
                AppActivityLeader.addActivity(p0)
            }

            override fun onActivityStarted(p0: Activity) {

            }

            override fun onActivityResumed(p0: Activity) {
                AppActivityLeader.pullActivity(p0)
            }

            override fun onActivityPaused(p0: Activity) {

            }

            override fun onActivityStopped(p0: Activity) {

            }

            override fun onActivitySaveInstanceState(p0: Activity, p1: Bundle) {

            }

            override fun onActivityDestroyed(p0: Activity) {
                AppActivityLeader.freeActivity(p0)
            }

        })
    }

    //在这里配置init即可   applicationFlag为true和false，都会跑这里的且只会跑一回
    abstract fun init(app:Application,applicationFlag:Boolean)
}