package com.work.provide_tool.data.entity

import android.os.Parcel
import android.os.Parcelable
import androidx.room.Entity
import androidx.room.Ignore
import androidx.room.PrimaryKey

@Entity(tableName = "player_data")
data class PlayerDataEntity(var rId:Long,
                            var pNa:String = "player",
                            var totalIntegral:Int = 0,//总积分
                            var iIntegral:Int = 0,//当前积分
                            var forwardIntegralArray:List<String>? = null,//前3轮积分
                            var afterIntegralArray:List<String>? = null//后3轮积分
) : Parcelable {
    @PrimaryKey
    var pId:Long? = null
    @Ignore
    var inputIntegral:String? = null

    constructor(parcel: Parcel) : this(
        parcel.readLong(),
        parcel.readString()!!,
        parcel.readInt(),
        parcel.readInt(),
        parcel.createStringArrayList(),
        parcel.createStringArrayList()
    ) {
        pId = parcel.readValue(Long::class.java.classLoader) as? Long
        inputIntegral = parcel.readString()
    }

    override fun writeToParcel(parcel: Parcel, flags: Int) {
        parcel.writeLong(rId)
        parcel.writeString(pNa)
        parcel.writeInt(totalIntegral)
        parcel.writeInt(iIntegral)
        parcel.writeStringList(forwardIntegralArray)
        parcel.writeStringList(afterIntegralArray)
        parcel.writeValue(pId)
        parcel.writeString(inputIntegral)
    }

    override fun describeContents(): Int {
        return 0
    }

    companion object CREATOR : Parcelable.Creator<PlayerDataEntity> {
        override fun createFromParcel(parcel: Parcel): PlayerDataEntity {
            return PlayerDataEntity(parcel)
        }

        override fun newArray(size: Int): Array<PlayerDataEntity?> {
            return arrayOfNulls(size)
        }
    }


}