package com.work.provide_tool.util

import android.content.Context
import android.speech.tts.TextToSpeech
import android.speech.tts.UtteranceProgressListener
import android.util.Log
import android.widget.Toast
import java.io.File
import java.util.*

//文字转语音
class TTSHelper(private var context: Context,
                var talkValue: String = "请输入文字",
                var locale:Locale = Locale.CHINA,
                var tone:Float = 1.0f,
                var rate:Float = 1.0f) {

    private var tSpeek:TextToSpeech? = null


    init {
        tSpeek = TextToSpeech(context){state->
            if(state == TextToSpeech.SUCCESS){
                var ret = tSpeek?.setLanguage(locale)
                if(ret != TextToSpeech.LANG_AVAILABLE && ret != TextToSpeech.LANG_COUNTRY_AVAILABLE){
                    Toast.makeText(context,"don't read this language", Toast.LENGTH_SHORT).show()
                }
            }
        }

        tSpeek?.run {
            setPitch(tone)//音调
            setSpeechRate(rate)//速率

            setOnUtteranceProgressListener(object: UtteranceProgressListener(){
                override fun onStart(p0: String?) {
                    Log.i("eee", "start = $p0")
                }

                override fun onDone(p0: String?) {
                    Log.i("eee", "do = $p0")
                }

                override fun onError(p0: String?) {
                    Log.i("eee", "err = $p0")
                }

            })
        }
    }

    private fun talk(){
        var req_tag = Random().nextInt(10001).toString()  // [0,1000)  int
        //setOnUtteranceProgressListener看进度
        tSpeek?.speak(talkValue,TextToSpeech.QUEUE_ADD,null,req_tag)
    }

    private fun note(){
        var req_tag = Random().nextInt(10001).toString() // 0-1001 int
        var file = context.getExternalFilesDir("audio")
        //setOnUtteranceProgressListener看进度
        var ret = tSpeek?.synthesizeToFile(talkValue,null, File(file,"aa.wav"),req_tag)// ret ok ?
    }

    private fun release(){
        tSpeek?.shutdown()
    }
}