package com.work.provide_tool.util

import android.annotation.SuppressLint
import android.widget.ImageView
import androidx.core.content.ContextCompat
import androidx.lifecycle.LifecycleOwner
import androidx.lifecycle.lifecycleScope
import com.bumptech.glide.Glide
import com.bumptech.glide.request.RequestOptions
import com.work.provide_tool.R
import com.work.provide_tool.app.IApp.Companion.app
import kotlinx.coroutines.Dispatchers
import kotlinx.coroutines.async
import kotlinx.coroutines.launch
//import kotlinx.coroutines.withContext


fun getAppColor(id:Int): Int {
    return ContextCompat.getColor(app,id)
}

fun getDrawIdentifier(idStr:String):Int{
    return app.resources.getIdentifier(idStr,"mipmap", app.packageName)
}

//keep 数据在刷ui的
fun keepDataUpdateWithUi(lfo: LifecycleOwner,otherThread:suspend ()->Unit,uiOfThread:()->Unit = {}){
    lfo.lifecycleScope.launch {
         lfo.lifecycleScope.async (Dispatchers.IO) {
            otherThread()
        }.await().apply {
            uiOfThread()
        }
    }
}


//-----------------------------------------Glide----------------------------------------------
var TPYER_CROP = "crop"
var TPYE_FIT = "fit"

//长方形
fun glideLoadRectangle(url: Any?,iv:ImageView?,tag: String = TPYER_CROP){
    glideGeneralOption(url,iv, getOptionGlide(tag, R.mipmap.icon_default_rectangle,R.mipmap.icon_default_rectangle))
}

//正方形
fun glideLoad(url: Any?,iv:ImageView?,tag: String = TPYER_CROP){
    glideGeneralOption(url,iv, getOptionGlide(tag, R.mipmap.icon_default,R.mipmap.icon_default))
}

//圆
fun glideLoadRound(url: Any?,iv:ImageView?,tag: String = TPYER_CROP){
    glideGeneralOption(url,iv, getOptionGlide(tag, R.mipmap.icon_default_round,R.mipmap.icon_default_round))
}

@SuppressLint("CheckResult")
private fun getOptionGlide(tag: String, placeholder:Int = 0, unload:Int = 0,doWork:RequestOptions.()->RequestOptions = {this}):RequestOptions{
    return RequestOptions().apply {
        when(tag){
            TPYER_CROP -> centerCrop()
            TPYE_FIT -> fitCenter()
            else -> centerCrop()
        }

        if(placeholder != 0){
            placeholder(placeholder)
        }

        if(unload != 0){
            error(unload)
        }
    }.doWork()
}

private fun glideGeneralOption(url:Any?,iv:ImageView?,requestOptions:RequestOptions){
    if(url == null){
        return
    }

    if(iv == null){
        return
    }

    when (url) {
        is String -> {
            url.run {
                if(isEmpty()){
                    return
                }

                if(startsWith("https")){
                    replace("https","http")
                }
            }
        }

        is Int -> {
            url.run {
                if(this == 0){
                    return
                }
            }
        }

        else -> {
            ToastUtil.show("glide load $url ??")
        }
    }


    Glide.with(app).load(url).apply(requestOptions).into(iv)
}
//-----------------------------------------/Glide----------------------------------------------