package com.work.provide_tool.widget;

import android.graphics.Rect;
import android.util.Log;
import android.view.View;

import androidx.recyclerview.widget.GridLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import java.util.Objects;

//只能用于Grid
public class GridSpacingItemWithDecoration extends RecyclerView.ItemDecoration {
    private boolean aroundTop;//top
    private boolean includeEdge;
    private boolean aroundLeft;//left
    private int interval;//间
    
    public GridSpacingItemWithDecoration(int interval){
        this(interval,true);
    }

    public GridSpacingItemWithDecoration(int interval, boolean includeEdge){
        this(interval,includeEdge,includeEdge);
    }

    public GridSpacingItemWithDecoration(int interval, boolean aroundLeft,boolean aroundTop) {
        this.interval= interval;
        this.aroundLeft = aroundLeft;
        this.aroundTop = aroundTop;
    }

    @Override
    public void getItemOffsets(Rect outRect, View view,RecyclerView recyclerView,RecyclerView.State state) {
        int position = recyclerView.getChildAdapterPosition(view);
        int total = Objects.requireNonNull(recyclerView.getAdapter()).getItemCount();
        GridLayoutManager gridLayoutManager = (GridLayoutManager) recyclerView.getLayoutManager();
        assert gridLayoutManager != null;
        int iCount = gridLayoutManager.getSpanCount();
        int column = position % iCount;
        if (aroundLeft) {
            outRect.left = interval - column * interval / iCount;
            outRect.right = (column + 1) * interval / iCount;
            if (position < iCount) {
                outRect.top = interval;
            }
            outRect.bottom = interval;
        } else {
            outRect.left = column * interval / iCount;
            outRect.right = interval - (column + 1) * interval / iCount;
            if (position < iCount) {
                outRect.top = interval;
            }
            outRect.bottom = interval;
        }

        if(!aroundTop){
            if(position <iCount){
                outRect.top = 0;
            }
            if(position+iCount>total-1){
                outRect.bottom = 0;
            }
        }
    }
}